//----------------------------------------------------------------------
// De/Cruncher 1.0
// Copyleft 1999, Vander Nunes
//
// This is free software, provided AS IS - use it at your own risk.
// If you use this code, a mention is appreciated but not required.
//
// This code is released as a technique sample, not meant to be an
// example of elegancy or portability.
//
// Module: crunch.cpp (sample application)
//----------------------------------------------------------------------

#include <stdlib.h>
#include <stdio.h>
#include "decrunch.h"

//
// A simple example of use. This will read a list of files
// from a text file and crunch all files to the end of the
// specified target file. Then the list will be read again
// and listed.
//
int main(int argc, char *argv[], char *envp[])
{
  printf("\n----------------------------------------------\n");
  printf("CRUNCH 1.0\n(C)1999, Vander Nunes");
  printf("\n----------------------------------------------\n");

  if (argc != 3)
  {
    printf("sintax: crunch <filelist.txt> <targetfile>\n");
    printf("sample: crunch bmps.txt demo.exe\n");
    exit(0);
  }

  printf("crunching %s into %s...",argv[1],argv[2]);
  CCrunch Cruncher;

  if (!Cruncher.Crunch(argv[1],argv[2]))
    printf("FAILED!\n");
  else
  {
    printf("--------------------------------------------\n");
    printf("Now testing\n");

    DWORD Offset;

    if (Cruncher.Decrunch(argv[2],&Offset))
    {
      printf("The list was found at offset %u.\n",Offset);
      printf("There are %u files crunched.\n",Cruncher.EntryCount());
      for (WORD n=0;n<Cruncher.EntryCount();n++)
      {
        printf("File  :%s - ",Cruncher.Entry(n)->cName);
        printf("Offset:%u - ",Cruncher.Entry(n)->dwOffset);
        printf("Size  :%u\n",Cruncher.Entry(n)->dwSize);
      }
    }
    else
    {
      printf("Something bad happened while decrunching...\n");
    }
  }

  return 0;
}
